﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.WebUI.UltraWebChart;
using Infragistics.UltraChart.Shared;
using Infragistics.UltraChart.Resources;
using Infragistics.UltraChart.Shared.Styles;
using System.Data;


public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

        if (this.UltraChart1.Data.DataSource == null)
        {
            // Configure chart for parent data
            this.UltraChart1.ChartType = ChartType.ColumnChart;
            this.UltraChart1.Data.ZeroAligned = true;
            // Set up datasource for parent data
            this.UltraChart1.Data.DataSource = GetColumnData();
            this.UltraChart1.Data.IncludeColumn(1, false);
            // Initialize DrillElement
            this.UltraChart1.Drill.Enabled = true;
            this.UltraChart1.Drill.DrillElements = new DrillElement[] { new DrillElement() };
            this.UltraChart1.Drill.DrillElements[0].DrillDown = new MyDrillDown(UltraChart1);
            this.UltraChart1.Data.DataBind();
        }

    }

    private DataTable GetColumnData()
    {
        // Create a new DataTable.
        System.Data.DataTable table = new DataTable("Table");
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);

        // Create second column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table. 
        table.Columns.Add(column);        


        // Make the ID column the primary key column.
        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;



        for (int i = 0; i <= 20; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;           
            table.Rows.Add(row);
        }
        return table;

    }


    protected void UltraChart1_ChartDataClicked(object sender, Infragistics.UltraChart.Shared.Events.ChartDataEventArgs e)
    {
        this.UltraChart1.Drill.DrillElements[0].DrillDown.Drill(e.DataRow,
      e.DataColumn, ChartType.LineChart, GetColumnData());

    }
}

internal class MyDrillDown : IDrillDown
{
    private UltraChart myChart;
    public MyDrillDown(UltraChart chart)
    {
        myChart = chart;
    }
    #region IDrillDown Members
    void Infragistics.UltraChart.Resources.IDrillDown.Drill(int row, int column,
      Infragistics.UltraChart.Shared.Styles.ChartType chartType,
      object dataSource)
    {
        // Initialize child chart
        myChart.ChartType = chartType;
        myChart.Drill.Enabled = false;
        myChart.Data.DataSource = dataSource;
        myChart.Data.IncludeColumn(0, true);
        myChart.Data.IncludeColumn(1, false);
        myChart.Data.DataBind();
    }
    #endregion
}

